//I swiped this from another one of my projects and tried to make it a little more generally useful
//by making NUM_DIGITS configurable.


obj/digit
	icon = 'number.dmi'
	icon_state = "0"
	layer = FLY_LAYER
	var/value = 0


readout
	var
		mob/owner
		baseIcon
		anchorX; anchorY
		digits[NUM_DIGITS]
		obj/typeIcon


	New(mob/theOwner, theIcon, theX, theY)
		. = ..()
		owner = theOwner
		anchorX = theX
		anchorY = theY

		if(theIcon)
			typeIcon = new()
			typeIcon.icon = theIcon
			typeIcon.layer = FLY_LAYER
			typeIcon.screen_loc = "[anchorX],[anchorY]"

		var
			tempx; tempy; modifyx

		for(var/i in 1 to NUM_DIGITS)
			var/obj/digit/newDigit = new()
			digits[i] = newDigit

			tempx = anchorX + round(i / 2 + 0.5)
			tempy = anchorY

			modifyx = ""
			if(!(i % 2)) modifyx = ":16"

			newDigit.screen_loc = "[tempx][modifyx],[tempy]"

		PrimeClient()


	proc/PrimeClient()
		//I broke this out of New() so you could, potentially, handle the case of a player who gets disconnected
		//and reconnects to the same mob -- you would need to call this for the new client.
		if(typeIcon)
			owner.client.screen += typeIcon

		for(var/obj/digit/newDigit in digits)
			owner.client.screen += newDigit


	proc/Update(value)
		var
			power
			curDigit
			obj/digit/D

		for(var/i in 1 to NUM_DIGITS)
			power = 10 ** (NUM_DIGITS - i)
			curDigit = round(value / power)
			D = digits[i]
			D.icon_state = num2text(curDigit)
			value -= curDigit * power

